
float DS18B20_temperature1, DS18B20_temperature2;

//--------------------------------------------------

#include <OneWire.h>
#include <DallasTemperature.h>

OneWire DS18B20_oneWire(9);
DallasTemperature DS18B20_sensors(&DS18B20_oneWire);

DeviceAddress deviceAddresses[2];

byte DS18B20_phase = 0;

void DS18B20_setup(void)
{
  DS18B20_sensors.begin();
  DS18B20_sensors.setWaitForConversion(false);
  DS18B20_sensors.getAddress(deviceAddresses[0], 0);
  DS18B20_sensors.getAddress(deviceAddresses[1], 1);
}

void DS18B20_loop(void)
{
  switch ( DS18B20_phase ) {
    case 0: DS18B20_sensors.requestTemperatures(); break;
    case 1: DS18B20_temperature1 = DS18B20_sensors.getTempC(deviceAddresses[0]); break;
    case 2: DS18B20_temperature2 = DS18B20_sensors.getTempC(deviceAddresses[1]); break;
  }

#ifdef DO_SERIAL
  Serial.print("DS18B20: ");
  Serial.print(DS18B20_temperature1);
  Serial.print(" degC, ");
  Serial.print(DS18B20_temperature2);
  Serial.println(" degC");
#endif

  DS18B20_phase = (DS18B20_phase + 1) % 3;
}
