#include <OneWire.h>
#include <DallasTemperature.h>

#define DO_SERIAL

OneWire oneWire(9);
DallasTemperature sensors(&oneWire);

DeviceAddress deviceAddresses[2];

int numSensors = 0;

void setup(void)
{
  sensors.begin();
#ifdef DO_SERIAL
  Serial.begin(115200);
  numSensors = sensors.getDeviceCount();
  Serial.print("numSensors: ");
  Serial.println(numSensors);
  //sensors.setWaitForConversion(false);
  sensors.getAddress(deviceAddresses[0], 0);
  sensors.getAddress(deviceAddresses[1], 1);
#endif
}
void loop(void)
{
  unsigned long before = millis();
  sensors.requestTemperatures();

#ifdef DO_SERIAL
  for (int i = 0; i < numSensors; i++) {
    Serial.print(sensors.getTempC(deviceAddresses[i]));
    Serial.print(", ");
  }
  Serial.println();
#endif

  unsigned long after = millis();
  //Serial.println(after - before);
  
  delay(500);
}
