/*
nRF24L01 library: https://github.com/gcopeland/RF24

nRF24L01 connections 
 1 - GND
 2 - VCC 3.3V !!! Ideally 3.0v, definitely not 5V
 3 - CE to Arduino pin 2
 4 - CSN to Arduino pin A6
 5 - SCK to Arduino pin 13
 6 - MOSI to Arduino pin 11
 7 - MISO to Arduino pin 12
 8 - UNUSED
*/
#include <SPI.h>
#include <nRF24L01.h>
#include <RF24.h>
#include "printf.h"

const uint64_t pipeOut =  0xE8E8F0F0E1LL;

RF24 radio(2, A0);

void setup() {
  Serial.begin(115200);
  printf_begin();
  
  radio.begin();
  radio.setAutoAck(false);
  radio.setDataRate(RF24_250KBPS);
  radio.openWritingPipe(pipeOut);

  radio.printDetails();
}

struct DummyPacket {
  int a;
  int b;
  int c;
};

DummyPacket dp;

void loop() {
  radio.write( &dp, sizeof(DummyPacket) );
}
