#include <SPI.h>
#include <SD.h>

#define DO_SERIAL

const int chipSelect = 10;

char filename[8] = "000.txt";
File dataFile;

void setup() {

#ifdef DO_SERIAL
  Serial.begin(115200);
#endif
  SD.begin(chipSelect);
  
  for (int i = 0; i < 1000; i++) {

    // don't use sprintf because it adds 1200 bytes to program size!
    filename[0] = '0' + (i / 100 % 10);
    filename[1] = '0' + (i / 10 % 10);
    filename[2] = '0' + (i % 10);
    
    if ( ! SD.exists(filename) )
      break;
  }

  Serial.print("Trying to write file: ");
  Serial.println(filename);
  
  dataFile = SD.open(filename, FILE_WRITE);

  bool success = false;

  if (dataFile) {
    success = true;
    Serial.println("Writing...");
    dataFile.println("It works!");
    dataFile.flush();
    dataFile.close();
  }

#ifdef DO_SERIAL
  if ( success )
    Serial.println("It worked!");
  else
    Serial.println("It didn't work!");
#endif

}

void loop(void) {

}
