#include <Si7021.h>

#define DO_SERIAL

Si7021 si7021;

int phase = 0;

void setup() {
  
  uint64_t serialNumber = 0ULL;

#ifdef DO_SERIAL
  Serial.begin(115200);
  si7021.begin();
#endif
}

float humidity, temperature;

void loop() {

  switch ( phase ) {
    case 0: si7021.measureHumidity_start(); break;
    case 1: humidity = si7021.measureHumidity_finish(); break;
    case 2: si7021.getTemperatureFromPreviousHumidityMeasurement_start(); break;
    case 3: temperature = si7021.getTemperatureFromPreviousHumidityMeasurement_finish(); break;
  }

#ifdef DO_SERIAL
  Serial.print("Humidity: ");
  Serial.print(humidity);
  Serial.print("% - Temperature: ");
  Serial.print(temperature);
  Serial.println("C");
#endif

  phase = (phase + 1) % 4;
  
  delay(100);
}
