
int MPU6050_accelerometer[3];
int MPU6050_temperature;

//--------------------------------------------------

#define CALIBRATION_COUNT       1000
#define MPU6050_ADDRESS         0x68
#define MPU6050_PWR_MGMT_1      0x6B   // R/W
#define ACCEL_VALUES_REGISTER   0x3B
#define TEMP_VALUES_REGISTER    0x41
#define GYRO_HIGH_BYTE_FIRST 

void MPU6050_setup() {
  twiWriteBytes(MPU6050_ADDRESS, 0x6B, 0x80);                     //PWR_MGMT_1    -- DEVICE_RESET 1
  delayMicroseconds(50000);
  twiWriteBytes(MPU6050_ADDRESS, 0x6B, 0x03);                     //PWR_MGMT_1    -- SLEEP 0; CYCLE 0; TEMP_DIS 0; CLKSEL 3 (PLL with Z Gyro reference)
  twiWriteBytes(MPU6050_ADDRESS, 0x1A, 0x00);                      //CONFIG        -- EXT_SYNC_SET 0 (disable input pin for data sync) ; default DLPF_CFG = 0 => ACC bandwidth = 260Hz  GYRO bandwidth = 256Hz)
  twiWriteBytes(MPU6050_ADDRESS, 0x1B, 0x08);                     //GYRO_CONFIG   -- FS_SEL = 3: Full scale set to 500 deg/sec
  twiWriteBytes(MPU6050_ADDRESS, MPU6050_PWR_MGMT_1, 0x00);
}

void MPU6050_loop() {

  twiReadData(MPU6050_ADDRESS, ACCEL_VALUES_REGISTER, (byte*)MPU6050_accelerometer, 6);
  twiReadData(MPU6050_ADDRESS, TEMP_VALUES_REGISTER, (byte*)&MPU6050_temperature, 2);
  
#ifdef DO_SERIAL
  Serial.print("MPU6050: ");
  Serial.print( (MPU6050_temperature/340.0f)+35 );
  Serial.print(" degC\t");
  Serial.print(MPU6050_accelerometer[0]/16384.0f);
  Serial.print("\t");
  Serial.print(MPU6050_accelerometer[1]/16384.0f);
  Serial.print("\t");
  Serial.print(MPU6050_accelerometer[2]/16384.0f);
  Serial.println("\t");
#endif

}

