#include <Wire.h>

#define DO_SERIAL

#define _SS_MAX_RX_BUFF 128

#include "i2cStuff.h"
#include "MPU6050.h"
#include "MS5611.h"
#include "BMP280.h"
#include "Si7021.h"
#include "DS18B20.h"
#include "GPS.h"

void setup() {
  Wire.begin();
  
#ifdef DO_SERIAL
  Serial.begin(9600);
#endif

  MPU6050_setup();
  MS5611_setup();
  BMP280_setup();
  Si7021_setup();
  DS18B20_setup();
  GPS_setup();
}

void loop() {

  static unsigned long lastOutputTime = 0;

  GPS_flush();

  unsigned long now = millis();
  if ( now - lastOutputTime > 1000 ) {
    MPU6050_loop();
      GPS_flush();
    MS5611_loop();
      GPS_flush();
    BMP280_loop();
      GPS_flush();
    Si7021_loop();
      GPS_flush();
    DS18B20_loop();
      GPS_flush();
    GPS_loop();
    Serial.println();
    lastOutputTime = now;
  }
}

